;Fractal example - Julia set v1.1
; from '7447' lik-sang compo entry (placed 4th)
; Tomasz <dox> Slanina
; dox@malenstwo.iinf.polsl.gliwice.pl

;fixed math 8.8 using unsigned 16x16 mul
;v1.1 prototype,own MUL16 (slower than QMUL) for lik-sang demo compo
;v1.0 QMUL

max_iter equ 16

w0 equ $ff95
w1 equ $ff96
w2 equ $ff97
p0 equ $ff99
p1 equ $ff9a
p2 equ $ff9b
p3 equ $ff9c


vram_check: MACRO
.www\@:
      ld a,[$ff41]
      bit 1,a
      jr nz,.www\@
ENDM


SECTION "ptable",HOME[0]
zmu SET 0
REPT 9
  dw zmu*320+$8000
zmu SET zmu+1
ENDR


SECTION "header",HOME[$100]
    nop
    jp   start
    ds 48
    db  "Fractal (JULIA)",$80
    db 0,0,0,0,0,0,0,0,0,0,0,0
start:
    di
    xor a
    ld [$ffff],a
    ld [$ff0f],a
    ld a,$30
    ld [$ff00],a
    ld a,1
    ld [$ff4d],a
    stop
w8:
    ld a,[$ff44]
    cp $91
    jr nz,w8
    ld hl,$ff40
    res 7,[hl]   ;lcd off
    ld sp,$cfff

    ld hl,fkol   ;palette
    ld a,128
    ld [$ff68],a
    ld c,8
hyua:
    ld a,[hl+]
    ld [$ff69],a
    dec c
    jr nz,hyua

    xor a
    ld [$ff4f],a
    ld hl,$8000  ;vram(tiles) clear
    push hl
    ld bc,20*9*16
    push bc
clr1:
    xor a
    ld [hl+],a
    dec bc
    ld a,b
    or c
    jr nz,clr1
    pop bc
    pop hl
    ld a,1
    ld [$ff4f],a
clr2:
    xor a
    ld [hl+],a
    dec bc
    ld a,b
    or c
    jr nz,clr2

    ld hl,fmapa
    ld de,$9800
    ld bc,1024
    push bc
    push de
mapacp:
    ld a,[hl+]
    ld [de],a
    inc de
    dec bc
    ld a,b
    or c
    jr nz,mapacp
    ld [$ff4f],a
    ld hl,fmap
    pop de
    pop bc
mapcp:
    ld a,[hl+]
    ld [de],a
    inc de
    dec bc
    ld a,b
    or c
    jr nz,mapcp
    ld hl,$ff40     ;lcd on
    set 7,[hl]
    ld b,a  ;y
f_y:
    ld c,0  ;x
f_x:
    push bc
    ld a,c
    sub 80
    ld d,a
    ld e,0;*256
REPT 6
    sra d
    rr e  ;/64
ENDR
    ;zx
    ld hl,f_zx
    ld [hl],e
    inc hl
    ld [hl],d
    inc hl
    ld a,b
    sub 72
    ld d,a
    ld e,0;*256
REPT 6
    sra d
    rr e  ;/64
ENDR
    ;zy
    ld [hl],e
    inc hl
    ld [hl],d
    ld c,0
f_inner:
    push bc
    ;zx*zx,zy*zy zx*zy
    ;abs_zx,_abs_zx
    ld a,[f_zx]
    ld e,a
    ld a,[f_zx+1]
    ld d,a
    bit 7,d
    jr z,w_zx
    ld a,d  ;*-1
    cpl
    ld d,a
    ld a,e
    cpl
    ld e,a
    inc de
w_zx:
    ld a,e
    ld [abs_zx],a
    ld a,d
    ld [abs_zx+1],a
    push de
    ld a,[f_zy]
    ld e,a
    ld a,[f_zy+1]
    ld d,a
    bit 7,d
    jr z,w_zy
    ld a,d   ;*-1
    cpl
    ld d,a
    ld a,e
    cpl
    ld e,a
    inc de
w_zy:
    ld a,e
    ld [abs_zy],a
    ld a,d
    ld [abs_zy+1],a
    ;zx*zx,zy*zy,zx*zy
    push de
    push de
    pop hl
    call mul16      ;zy*zy
    ld a,[w1]
    ld [zyzy],a
    ld a,[w2]
    ld [zyzy+1],a
    ;zy*zy stored
    pop bc
    pop de
    push de
    pop hl
    push de
    push bc
    call mul16
    ld a,[w1]
    ld [zxzx],a
    ld a,[w2]
    ld [zxzx+1],a
    ;zx*zx stored
    pop hl
    pop de
    call mul16
    ld a,[w1]
    ld l,a
    ld a,[w2]
    ld h,a
    ld c,0
    ld a,[f_zx+1]
    bit 7,a
    jr z,wr
    ld c,1
wr:
    ld a,[f_zy+1]
    bit 7,a
    jr z,we
    ld a,c
    xor 1
    ld c,a
we:
    ld a,c
    or a
    jr z,nzm
    ld a,h  ;sign
    cpl
    ld h,a
    ld a,l
    cpl
    ld l,a
    inc hl
nzm:
    ld a,l
    ld [zxzy],a
    ld a,h
    ld [zxzy+1],a
    ;zx*zy stored
    add hl,hl
    ld bc,-192
    add hl,bc
    ld a,l
    ld [f_zy],a
    ld a,h
    ld [f_zy+1],a
    ;new zy
    ld a,[zxzx]
    ld e,a
    ld a,[zxzx+1]
    ld d,a
    push de
    ld a,[zyzy]
    cpl
    ld l,a
    ld a,[zyzy+1]
    cpl
    ld h,a
    inc hl
    add hl,de;zx*zx-zy*zy
    ld bc,-64
    add hl,bc
    ld a,l
    ld [f_zx],a
    ld a,h
    ld [f_zx+1],a
    ;new zx
    pop de;zxzx
    ld a,[zyzy]
    ld l,a
    ld a,[zyzy+1]
    ld h,a
    add hl,de
    ld bc,-4*256
    add hl,bc
    jr nc,nwq
    pop bc
    ld a,c
    srl a
    srl a
    and %11
    pop bc
    push bc
    inc a
    call dplot
    pop bc
    jr fs
nwq:
    pop bc
    inc c
    ld a,c
    cp max_iter
    jp nz,f_inner       ;next iter
    pop bc
fs:
    inc c
    ld a,c
    cp 160
    jp nz,f_x
    inc b
    ld a,b
    cp 144
    jp nz,f_y
end:
    jr end

dplot:
;b=y
;c=x
;a=color
    or a
    ret z
    push af
    xor a
    ld [bankv],a
    ld a,b
    cp 9*8
    jr c,ok
    sub 9*8
    ld b,a
    ld a,1
    ld [bankv],a
    ld a,b
ok:
    srl a
    srl a
    and %11111110
    ld h,0
    ld l,a
    ld a,[hl+]
    ld e,a
    ld d,[hl];de= address in vram
    ld a,b
    and %111
    add a,a
    or e
    ld e,a
    ld a,c
    push af
    and %11111000
    add a,a
    ld c,a
    ld a,0 ;NOT xor
    adc d
    ld d,a
    ld a,c
    add e
    ld e,a
    ld a,0
    adc d
    ld d,a
    pop af
    and %111
    inc a
    ld c,1
rotate:
    rrc c
    dec a
    jr nz,rotate
    ld a,[bankv]
    ld [$ff4f],a
    pop af
    cp 1
    jr nz,n1_k
    vram_check
    ld a,[de]
    or c
    ld [de],a
    ret
n1_k:
    cp 2
    jr nz,n2_k
    inc de
    vram_check
    ld a,[de]
    or c
    ld [de],a
    ret
n2_k:
    vram_check
    ld a,[de]
    or c
    ld [de],a
    inc de
    ld a,[de]
    or c
    ld [de],a
    ret

include "mul.asm"

fkol:
db 31,2,0,124,0,125,96,125

fmap:
REPT 2
tnmb SET 0
REPT 9
REPT 20
db tnmb
tnmb SET tnmb+1
ENDR
REPT 6
dw 0
ENDR
ENDR
ENDR

fmapa:
REPT 9*32
db 0
ENDR

REPT 9*32
db 8
ENDR


section "ram", BSS[$c000]

f_zx:   ds 2
f_zy:   ds 2
abs_zx: ds 2
abs_zy: ds 2
zxzx:   ds 2  ;zx*zx/256
zyzy:   ds 2  ;zy*zy/256
zxzy:   ds 2  ;zx*zy/256
bankv   ds 1






